var GalleryWindow = 0;
var RawTotalLink = 0;
var LinksIssued = 0;
var LinksAnalyzed = 0;
var LinksErrored = 0;
var LinksTimedout = 0;
var TotalBytes = 0;
var LinksTotalNode = 0;
var LinksIssuedNode = 0;
var LinksAnalyzedNode = 0;
var LinksErroredNode = 0;
var LinksTimedoutNode = 0;
var ImagesNumNode = 0;
var TotalBytesNode = 0;
var StatusNode = 0;
var TimeElapsedNode = 0;
var NextLinkId = 0;
var FinishedLinks = 0;
var NumOfImages = 0;
var MaxNumOfImages = 0;
var NumOfPages = 0;
var MaxNumOfPages = 0;
var LimitTime = false;
var CrawlTime = 0;
var GoodLinks = null;
var ValidLinks = null;
var ValidLinkTimers = null;
var GoodLinksDepth = null;
var Files = null;
var Timers = null;
var Bars = null;
var Timeout = 0;
var LinkedFiles = false;
var SearchRegExp = 0;
var ValidateRegExp = 0;
var BackgroundRegExp = 0;
var Background = false;
var Verbose = false;
var ShowDesc = false;
var ShowUrls = false;
var UseGeneric = false;
var AnalyzeMime = true;
var IgnoreNoImage = false;
var IgnoreBroken = false;
var LimitNumOfImages = false;
var LimitNumOfPages = false;
var BigJpg = false;
var BJwidth = 0;
var BJheight = 0;
var BJtarget = 0;
var Gallery = 0;
var LinkTemplate = 0;
var LinkAnchor = 0;
var LinkImage = 0;
var LinkDesc = 0;
var LinkOrigUrlDiv = 0;
var LinkOrigUrl = 0;
var PostProcessingStarted = false;
var MaxDepth = 0;
var Tockens = 0;
var MaxImageWidth = 0;
var StartTime = 0;
var ResizeMode = "";
var ResizeWidth = 0;
var ResizeHeight = 0;
var bgColor = 0;
var textColor = 0;
var GalleryTarget = 0;
var UrlFilter = "";
var OptOutFilters = "";
var FileFilterType = 0;
var FileFilterRegExp = 0;
var L10n = null;
var StopButton;
var ExportButton;
var SelectButton;
var DownloadButton;

var TotalLinksStr;
var IssuedLinksStr;
var AnalyzedLinksStr;
var ErroredLinksStr;
var TimedoutLinksStr;
var NumOfImagesStr;
var TotalBytesStr;
var ElapsedTimeStr;
var DoneStr;
var Retries503;

var FirstRowWithInvisible = 0;
var FirstTransparent = 0;

var LuckyMime = null;
var MimeList = null;
var MimeCheckList = null;
var MimeFinalNameList = null;

var prefService;
var prefs;

function FoxySpiderCrawl()
{
  prefService = Components.classes["@mozilla.org/preferences-service;1"]
                       .getService(Components.interfaces.nsIPrefService);
  prefs = Components.classes["@mozilla.org/preferences-service;1"]
                       .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");
      
  var lastCrawlUrl = prefs.getCharPref("lastcrawlurl");
  var Doc;
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	                     .getService(Components.interfaces.nsIWindowMediator);
  var browserEnumerator = wm.getEnumerator("navigator:browser");

  var found = false;
  while (!found && browserEnumerator.hasMoreElements())
  {
    var browserWin = browserEnumerator.getNext();
    var tabbrowser = browserWin.gBrowser;

    // Check each tab of this browser instance
    var numTabs = tabbrowser.browsers.length;
    for (var index = 0;index < numTabs;index++)
    {
      var currentBrowser = tabbrowser.getBrowserAtIndex(index);
      if (lastCrawlUrl == currentBrowser.currentURI.spec)
      {
            Doc = currentBrowser.contentDocument;
  	        found = true;
  	        break;
      }
    }
  }
  
  if (!found)
    return;
  
  InitL10n();
    
  RotateButton();

  LinksIssued = 0;
  LinksAnalyzed = 0;
  LinksErrored = 0;
  LinksTimedout = 0;
  TotalBytes = 0;
  NextLinkId = 0;
  FinishedLinks = 0;
  NumOfImages = 0;
  NumOfPages = 0;
  GoodLinks = new Array();
  GoodLinksDepth = new Array();
  Files = new Array();
  Timers = new Array();
  ValidLinks = new Array();
  ValidLinkTimers = new Array();
  LuckyMime = new Array();
  MimeList = new Array();
  MimeCheckList = new Array();
  MimeFinalNameList = new Array();
  Timeout = prefs.getIntPref("timeout");
  Background = prefs.getBoolPref("background");
  Verbose = prefs.getBoolPref("verbose");
  ShowDesc = prefs.getBoolPref("showdesc");
  ShowUrls = prefs.getBoolPref("showurls");
  UseGeneric = prefs.getBoolPref("usegeneric");
  AnalyzeMime = prefs.getBoolPref("luckymime");
  IgnoreNoImage = prefs.getBoolPref("ignorenoimage");
  IgnoreBroken = prefs.getBoolPref("ignorebroken");
  LimitNumOfImages = prefs.getBoolPref("limitgallery");
  LimitNumOfPages = prefs.getBoolPref("limitcrawler");
  LimitTime = prefs.getBoolPref("limittime");
  BigJpg = prefs.getBoolPref("bigjpg");
  BJwidth = prefs.getIntPref("bjwidth");
  BJheight = prefs.getIntPref("bjheight");
  BJtarget = prefs.getIntPref("bjtarget");
  ResizeMode = prefs.getCharPref("resize");
  ResizeWidth = prefs.getIntPref("width");
  ResizeHeight = prefs.getIntPref("height");
  ResizeHeight = prefs.getIntPref("height");
  bgColor = prefs.getCharPref("bgcolor");
  textColor = prefs.getCharPref("textcolor");
  GalleryTarget = prefs.getIntPref("gallerytarget");
  
  document.body.style.backgroundColor = bgColor;
  document.body.style.color = textColor;
  document.getElementById("FoxySpiderGallery").style.backgroundColor = bgColor;
  document.getElementById("FoxySpiderGallery").style.color = textColor;

  PostProcessingStarted = false;
  MaxDepth = prefs.getIntPref("crawldepth");
  Tockens = prefs.getIntPref("connections");
  MaxNumOfImages = prefs.getIntPref("numofimages");
  MaxNumOfPages = prefs.getIntPref("numofpages");
  CrawlTime = prefs.getIntPref("crawltime");
  var urlfilter = prefs.getCharPref("urlfilter");
  prefs.setCharPref("urlfilter","*");
  urlfilter = urlfilter.replace(/\\/g,"/");
  urlfilter = urlfilter.replace(/\./g,"\\.")
  urlfilter = urlfilter.replace(/\*/g,".*");
  urlfilter = urlfilter.replace(/\+/g,"\\+");
  urlfilter = urlfilter.replace(/\?/g,"\\?");
  urlfilter = urlfilter.replace(/https?:\/\//g,"https?://");
  UrlFilter = RegExp(urlfilter,"gi");
  FileFilterType = prefs.getIntPref("filefiltertype");
  prefs.setIntPref("filefiltertype",0);
  
  var filterlist = prefs.getCharPref("filterlist");
  var list = (filterlist ? filterlist.split(" ") : "");
  OptOutFilters = new Array();
  for (var i = 0;i < list.length;i++)
   {
      if (list[i] != "")
      {
         var item = list[i].split("\b");
         var pattern = item[0];
         var enabled = (item.length == 1);
         if (enabled)
         {
           pattern = pattern.replace(/\\/g,"/");
           pattern = pattern.replace(/\./g,"\\.")
           pattern = pattern.replace(/\*/g,".*");
           pattern = pattern.replace(/\+/g,"\\+");
           pattern = pattern.replace(/\?/g,"\\?");
           pattern = pattern.replace(/https?:\/\//g,"https?://");
           OptOutFilters[OptOutFilters.length] = RegExp(pattern,"gi");
         }
      }
   }
  
  var FileFilter = prefs.getCharPref("filefilter");
  prefs.setCharPref("filefilter","");
  var FileFilterMode = prefs.getIntPref("filefiltermode");
  prefs.setIntPref("filefiltermode",0);
  
  FileFilter = FileFilter.replace(/^\W*|\W*$/g,"");    // removes head/tail spaces
  FileFilter = FileFilter.replace(/\W+/g," ");         // Merge multiple white-spcaes
  if (IsEmptyString(FileFilter))                       // malformed filter
  {
    FileFilterType = 0;
    FileFilterMode = 0;
  }
  
  if (FileFilterMode == 1)
    FileFilter = "\\b(" + FileFilter.replace(/ /g,"|") + ")\\b";
  else if (FileFilterMode == 2)
    FileFilter = "(?=.*?\\b" + FileFilter.replace(/ /g,"\\b)(?=.*?\\b") + "\\b).*";
  else
    FileFilter = ".*";
  FileFilterRegExp = RegExp(FileFilter,"gi");
  StartTime = Date.now();

  var FileTypes = "()";
  var Extensions = "()";
  var BackgroundExtensions = "()";
  if (prefs.getBoolPref("video"))
  {
    FileTypes = ConcatBracketedString(FileTypes,"+",L10n.GetStringFromName("FoxySpiderGallery.FileType.Video"));
    Extensions = ConcatBracketedString(Extensions,"|",prefs.getCharPref("vidext"));
    if (prefs.getIntPref("vidtarget") == 2)
      BackgroundExtensions = ConcatBracketedString(BackgroundExtensions,"|",prefs.getCharPref("vidext"));
    MimeList.push(/^video\//i);
  }
  if (prefs.getBoolPref("audio"))
  {
    FileTypes = ConcatBracketedString(FileTypes,"+",L10n.GetStringFromName("FoxySpiderGallery.FileType.Audio"));
    Extensions = ConcatBracketedString(Extensions,"|",prefs.getCharPref("audext"));
    if (prefs.getIntPref("audtarget") == 2)
      BackgroundExtensions = ConcatBracketedString(BackgroundExtensions,"|",prefs.getCharPref("audext"));
    MimeList.push(/^audio\//i);
  }
  if (prefs.getBoolPref("image"))
  {
    FileTypes = ConcatBracketedString(FileTypes,"+",L10n.GetStringFromName("FoxySpiderGallery.FileType.Image"));
    Extensions = ConcatBracketedString(Extensions,"|",prefs.getCharPref("imgext"));
    if (prefs.getIntPref("imgtarget") == 2)
      BackgroundExtensions = ConcatBracketedString(BackgroundExtensions,"|",prefs.getCharPref("imgext"));
    MimeList.push(/^image\//i);
  }
  if (prefs.getBoolPref("document"))
  {
    FileTypes = ConcatBracketedString(FileTypes,"+",L10n.GetStringFromName("FoxySpiderGallery.FileType.Document"));
    Extensions = ConcatBracketedString(Extensions,"|",prefs.getCharPref("docext"));
    if (prefs.getIntPref("doctarget") == 2)
      BackgroundExtensions = ConcatBracketedString(BackgroundExtensions,"|",prefs.getCharPref("docext"));
    MimeList.push(/^application\/pdf/i);
    MimeList.push(/^application\/(ms)?\-?word/i);
    MimeList.push(/^application\/(ms)?\-?powerpoint/i);
    MimeList.push(/^application\/(ms)?\-?excel/i);
    MimeList.push(/^application\/vnd/i);
  }
  if (prefs.getBoolPref("other"))
  {
    FileTypes = ConcatBracketedString(FileTypes,"+",L10n.GetStringFromName("FoxySpiderGallery.FileType.Other"));
    Extensions = ConcatBracketedString(Extensions,"|",prefs.getCharPref("othext"));
    if (prefs.getIntPref("othtarget") == 2)
      BackgroundExtensions = ConcatBracketedString(BackgroundExtensions,"|",prefs.getCharPref("othext"));
  }
  
  if (FileTypes == "()")
    LinkedFiles = false;
  else
    LinkedFiles = true;
  
  SearchRegExp = new RegExp("<a[^>]*href[^>]*\\." + Extensions + "[^>]*>.*?(?=<\\/?a)","gi");
  ValidateRegExp = new RegExp("\\." + Extensions + "(\\?.*)?$","gi");
  BackgroundRegExp = new RegExp("\\." + BackgroundExtensions + "(\\?.*)?$","gi");

  document.getElementById("StopButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.StopButton");
  document.getElementById("ExportButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.ExportButton");
  document.getElementById("SelectNone").textContent = L10n.GetStringFromName("FoxySpiderGallery.SelectNone");
  document.getElementById("SelectManually").textContent = L10n.GetStringFromName("FoxySpiderGallery.SelectManually");
  document.getElementById("SelectAll").textContent = L10n.GetStringFromName("FoxySpiderGallery.SelectAll");
  document.getElementById("SelectByKeywords").textContent = L10n.GetStringFromName("FoxySpiderGallery.SelectByKeywords");
  document.getElementById("DownloadButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.DownloadButton");
  document.getElementById("ShareTell").textContent = L10n.GetStringFromName("FoxySpiderGallery.Share.Tell");
  document.getElementById("ShareFacebook").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Facebook");
  document.getElementById("ShareTwitter").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Twitter");
  document.getElementById("ShareGoogle").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Google");
  document.getElementById("ShareMail").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Mail");
  document.getElementById("ShareDigg").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Digg");
  document.getElementById("ShareStumbleupon").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Stumbleupon");
  document.getElementById("ShareMore").title = L10n.GetStringFromName("FoxySpiderGallery.Share.More");
  
  document.getElementById("FacebookButtonCount").src = "http://www.facebook.com/plugins/like.php?href=http%3A%2F%2Fwww.facebook.com%2FFoxySpider&layout=button_count&show_faces=false&width=100&action=like&colorscheme=light&height=21";
  document.getElementById("FacebookButtonStandard").src = "http://www.facebook.com/plugins/like.php?href=http%3A%2F%2Fwww.facebook.com%2FFoxySpider&layout=standard&show_faces=false&width=450&action=like&colorscheme=light&height=25";
  document.getElementById("TwitterFollow").src = "http://platform.twitter.com/widgets/follow_button.html?screen_name=foxyspider&show_screen_name=false";

  document.getElementById("DeleteButton").title = L10n.GetStringFromName("FoxySpiderGallery.Tooltip.Delete");
  document.getElementById("DownloadFileButton").title = L10n.GetStringFromName("FoxySpiderGallery.Tooltip.DownloadFile");
  document.getElementById("FacebookButton").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Facebook");
  document.getElementById("TwitterButton").title = L10n.GetStringFromName("FoxySpiderGallery.Share.Twitter");
  
  DoneStr = L10n.GetStringFromName("FoxySpiderGallery.Status.done");
 
  GalleryWindow = document.defaultView;
  
  GoodLinks[0] = Doc.URL;
  GoodLinksDepth[0] = 0;
  RawTotalLink = 1;
  NumOfPages = 1;
  
  document.getElementById("StatusBar").style.display = "inline-block";
  StopButton=document.getElementById("StopButton");
  StopButton.style.display = "inline-block";
  if (StopButton.hasAttribute("disabled"))
    StopButton.removeAttribute("disabled");
  ExportButton=document.getElementById("ExportButton");
  ExportButton.style.display = "inline-block";
  ExportButton.disabled = "disabled";
  SelectButton=document.getElementById("SelectButton");
  SelectButton.style.display = "inline-block";
  SelectButton.disabled = "disabled";
  document.getElementById("SelectKeywords").value = "";
  DownloadButton=document.getElementById("DownloadButton");
  DownloadButton.style.display = "inline-block";
  DownloadButton.disabled = "disabled";
  document.getElementById("Footer").style.display = "block";
  Retries503 = 0;
    
  document.getElementById("Header").style.visibility = "visible";
  document.getElementById("Header").style.display = "block";
  
  if (Verbose)
  {
    LinksTotalNode = document.getElementById("TotalLinks");
    LinksIssuedNode = document.getElementById("IssuedLinks");
    LinksAnalyzedNode = document.getElementById("AnalyzedLinks");
    LinksErroredNode = document.getElementById("ErroredLinks");
    LinksTimedoutNode = document.getElementById("TimedOutLinks");
    ImagesNumNode = document.getElementById("NumOfImages");
    TotalBytesNode = document.getElementById("TotalBytes");
    TimeElapsedNode = document.getElementById("TimeElapsed");

    TotalLinksStr = L10n.GetStringFromName("FoxySpiderGallery.TotalLinks");
    IssuedLinksStr = L10n.GetStringFromName("FoxySpiderGallery.IssuedLinks");
    AnalyzedLinksStr = L10n.GetStringFromName("FoxySpiderGallery.AnalyzedLinks");
    ErroredLinksStr = L10n.GetStringFromName("FoxySpiderGallery.ErroredLinks");
    TimedoutLinksStr = L10n.GetStringFromName("FoxySpiderGallery.TimedoutLinks");
    NumOfImagesStr = L10n.GetStringFromName("FoxySpiderGallery.NumOfImages");
    TotalBytesStr = L10n.GetStringFromName("FoxySpiderGallery.TotalBytes");
    ElapsedTimeStr = L10n.GetStringFromName("FoxySpiderGallery.ElapsedTime");
    
    UpdateVerboseData();
  }

  var DocTitle = document.getElementsByTagName("TITLE");
  DocTitle[0].textContent = DocTitle[0].textContent + " " + FileTypes + " - " + Doc.URL;
  document.title = DocTitle[0].textContent;

  StatusNode = document.getElementById("Status");
  Bars = document.getElementsByTagName("SPAN");
  
  Gallery = document.getElementById("Gallery");

  MaxImageWidth = Gallery.clientWidth - 50;
  LinkTemplate = document.getElementById("LinkTemplate");
  LinkAnchor = document.getElementById("LinkAnchor");
  LinkImage = document.getElementById("LinkImage");
  LinkDesc = document.getElementById("LinkDesc");
  LinkOrigUrlDiv = document.getElementById("LinkOrigUrlDiv");
  LinkOrigUrl = document.getElementById("LinkOrigUrl");

  if (MaxDepth > 0 &&
      (!LimitNumOfPages || NumOfPages < MaxNumOfPages))
  {
    var AElements = Doc.getElementsByTagName("A");
    RawTotalLink += AElements.length;
    for  (var i = 0;i < AElements.length;i++)
    {
      if (!AElements[i].hasAttribute("href"))
        continue;
        
      var ClearUrl = AElements[i].href;//.match(/[^#]*/gi)[0];
        
      if (!IsLinkToFile(ClearUrl) &&
          ClearUrl.match(/(javascript|mailto|irc):/i) == null &&
          ClearUrl.match(/["'\*\\ ]/i) == null &&
          IsInUrlFilter(ClearUrl) &&
          !IsOptOutFiltered(ClearUrl) &&
          IsKnownLink(ClearUrl) == false)
      {
        GoodLinksDepth[GoodLinks.length] = 1;
        GoodLinks[GoodLinks.length] = ClearUrl;
        NumOfPages++;
        if (LimitNumOfPages && NumOfPages == MaxNumOfPages)
          break;
      }
    }
    if (Verbose)
    {
      UpdateVerboseData();
    }
  }
  
  if (prefs.getBoolPref("fadein"))
    setTimeout(function () {FadeInImages();},100);
  else
    LinkImage.style.opacity = 1;

  CheckNextLinkForFiles();
}

function ConcatBracketedString(OriginalStr,Seperator,NewString)
{
  if (OriginalStr == "()")
    return "(" + NewString + ")";
  else
    return OriginalStr.replace(")",Seperator) + NewString + ")";
}

function IsKnownLink (Link)
{
  for  (var i = 0;i < GoodLinks.length;i++)
  {
    if (GoodLinks[i] == Link)
    {
      return true;
    }
  }
  return false;
}

function IsKnownFile(File)
{
  for  (var i = 0;i < Files.length;i++)
  {
    if (Files[i] == File)
    {
      return true;
    }
  }
  return false;
}

function IsInMimeCheckList(Link)
{
  for  (var i = 0;i < MimeCheckList.length;i++)
  {
    if (MimeCheckList[i] == Link)
    {
      return true;
    }
  }
  return false;
}

function RemoveFile(File)
{
  for  (var i = 0;i < Files.length;i++)
  {
    if (Files[i] == File)
    {
      var lastFile = Files.pop();
      if (lastFile != File)
        Files[i] = lastFile;
      return;
    }
  }
}

function CheckNextLinkForFiles()
{
  var BarsNum = Math.min(50,FinishedLinks/GoodLinks.length*50);
  for (var i=0;i<=50;i++)
  {
    if (i<=BarsNum)
      Bars[i].style.backgroundColor = "blue";
    else
      Bars[i].style.backgroundColor = "transparent";
  }
  
  if (GalleryWindow.closed)
  {
    TraceOut("FoxySpider: gallery window/tab was closed!");
    ResetButton();
    return;
  }
  if (StopButton.value == "stop")
  {
    TraceOut("FoxySpider: user pressed stop button!");
    StartPostProcessing();
    return;
  }
  
  if (LimitTime && (Date.now() - StartTime)/1000 > CrawlTime)
  {
    TraceOut("FoxySpider: crawl time is up!");
    StopButton.value = "stop";
    StopButton.disabled = "disabled";
    StartPostProcessing();
    return;
  }

  if (Verbose)
  {
    UpdateVerboseData();
  }
  
  // just make sure it keeps on rotating
  RotateButton();
  
  while (Tockens > 0 &&
          NextLinkId  < GoodLinks.length &&
          (!LimitNumOfImages || NumOfImages < MaxNumOfImages))
  {
    Tockens--;
    CheckLinkForFiles(GoodLinks[NextLinkId],NextLinkId);
    NextLinkId++;
    
    StatusNode.textContent = Math.round(FinishedLinks/GoodLinks.length*100) + "%";
  }
}

function CheckLinkForFiles(Link,LinkId)
{
  if (Verbose)
  {
    LinksIssued++;
    UpdateVerboseData();
  }
  
  var req = new XMLHttpRequest();
  Timers[LinkId] = setTimeout(function () {HandleLinkTimeout(LinkId,req);},Timeout);
  
  try
  {
    req.open("GET",Link,true);
    req.onreadystatechange = function ()
    {
      try
      {
        if (Timers == null) // another connection has already closed everything
          return;
          
        if (Timers[LinkId] == 0) // this is an old request
          return;
          
        if (StopButton.value == "stop")
        {
          if (Timers[LinkId] != 0)
          {
            clearTimeout(Timers[LinkId]);
            FinishedLinks++;
            Timers[LinkId] = 0;
          }
          req.abort();
          CheckNextLinkForFiles(); // it will take care of the graceful stop...
          return;
        }
        
        var mime = req.getResponseHeader("Content-Type");
        if (mime != null && AnalyzeMime)
        {
          LuckyMime[GoodLinks[LinkId]] = mime;
          if (MimeMatch(mime))
            MimeFinalNameList[GoodLinks[LinkId]] = req.channel.URI.spec;
        }
        
        if ((req.readyState > 1 && req.status >= 400) || (req.readyState == 4 && req.status != 200) ||
            (mime && (!mime.match(/\/html/i) || GoodLinksDepth[LinkId] > MaxDepth || IsInMimeCheckList(GoodLinks[LinkId]))))
        {
          TraceOut("FoxySpider error: " + GoodLinks[LinkId] + " (" + mime + ") " + req.readyState + "/" + req.status + " depth=" + GoodLinksDepth[LinkId]);
          
          if (req.status == 503 && Retries503 < 100)
          {
            GoodLinksDepth[GoodLinks.length] = GoodLinksDepth[LinkId];
            GoodLinks[GoodLinks.length] = GoodLinks[LinkId];
            NumOfPages++;

            if (Verbose)
            {
              UpdateVerboseData();
            }
            Retries503++;
          }
          
          Tockens++;
                  
          if (Timers[LinkId] != 0)
          {
            clearTimeout(Timers[LinkId]);
            FinishedLinks++;
            Timers[LinkId] = 0;
          }
          req.abort();
          
          if (AnalyzeMime && LuckyMime[GoodLinks[LinkId]] == undefined)
            LuckyMime[GoodLinks[LinkId]] = "text/html";
          
          ArrangeImages();
          
          if (Verbose)
          {
            LinksErrored++;
            UpdateVerboseData();
          }
          CheckNextLinkForFiles();
  
          if (FinishedLinks >= GoodLinks.length ||
              (LimitNumOfImages && NumOfImages >= MaxNumOfImages))
          {
            StartPostProcessing();
          }
        }
        if (req.readyState == 4 && req.status == 200)
        {
          Tockens++;
          if (Verbose)
          {
            TotalBytes += req.responseText.length;
            UpdateVerboseData();
          }
                  
          if (Timers[LinkId] != 0)
          {
            clearTimeout(Timers[LinkId]);
            FinishedLinks++;
            Timers[LinkId] = 0;
          }
          
          if (!LimitNumOfImages || NumOfImages < MaxNumOfImages)
          {
            var Domain = GetDomain(req);
            
            // replace new line charachters with spaces
            var UnbreakedResponseText = req.responseText.replace(/[\x0A\x0D]/g," ");
            // Replace HTML special characters
            UnbreakedResponseText = UnbreakedResponseText.replace(/&(#0?60|lt);/g,"<").replace(/&(#0?62|gt);/g,">");
            UnbreakedResponseText = UnbreakedResponseText.replace(/&(#0?34|quot|ldquo|rdquo);/g,'"').replace(/&(#0?39|lsquo|rsquo);/g,"'");
            UnbreakedResponseText = UnbreakedResponseText.replace(/&(#0?38|amp);/g,"&").replace(/&(#160|nbsp);/g," ");
            
            // Add located frame src
            if (GoodLinksDepth[LinkId] <= MaxDepth &&
                (!LimitNumOfPages || NumOfPages < MaxNumOfPages))
            {
              var SrcFrames = UnbreakedResponseText.match(/<i?frame[^>]*src.*?>/gi);
              if (SrcFrames)
              {
                RawTotalLink += SrcFrames.length;
                for (var i=0;i<SrcFrames.length;i++)
                {
                  var TempSrc = GetQuotedAttribute(SrcFrames[i],"src",false);
                  if (!TempSrc)
                    continue;
                    
                  var ClearUrl = TempSrc;//.match(/[^#]*/gi)[0];
                  if (!ClearUrl.match(/^http/i))
                    ClearUrl = AddDomain(ClearUrl,Domain);
                  ClearUrl = FixLink(ClearUrl);
                  
                  if (!IsLinkToFile(ClearUrl) &&
                      ClearUrl.match(/(javascript|mailto|irc):/i) == null &&
                      ClearUrl.match(/["'\*\\ ]/i) == null &&
                      IsInUrlFilter(ClearUrl) &&
                      !IsOptOutFiltered(ClearUrl) &&
                      IsKnownLink(ClearUrl) == false)
                  {
                    GoodLinksDepth[GoodLinks.length] = GoodLinksDepth[LinkId];
                    GoodLinks[GoodLinks.length] = ClearUrl;
                    NumOfPages++;
                    if (LimitNumOfPages && NumOfPages == MaxNumOfPages)
                      break;
                  }
                }
                if (Verbose)
                {
                  UpdateVerboseData();
                }
              }
            }
            
            // Add located hrefs to GoodLinks
            if (GoodLinksDepth[LinkId] < MaxDepth &&
                (!LimitNumOfPages || NumOfPages < MaxNumOfPages))
            {
              var HrefAnchors = UnbreakedResponseText.match(/<a[^>]*href.*?>/gi);
              if (HrefAnchors)
              {
                RawTotalLink += HrefAnchors.length;
                for (var i=0;i<HrefAnchors.length;i++)
                {
                  var TempHref = GetQuotedAttribute(HrefAnchors[i],"href",false);
                  if (!TempHref)
                    continue;
                    
                  var ClearUrl = TempHref;//.match(/[^#]*/gi)[0];
                  if (!ClearUrl.match(/^http/i))
                    ClearUrl = AddDomain(ClearUrl,Domain);
                  ClearUrl = FixLink(ClearUrl);
                  
                  if (!IsLinkToFile(ClearUrl) &&
                      ClearUrl.match(/(javascript|mailto|irc):/i) == null &&
                      ClearUrl.match(/["'\*\\ ]/i) == null &&
                      IsInUrlFilter(ClearUrl) &&
                      !IsOptOutFiltered(ClearUrl) &&
                      IsKnownLink(ClearUrl) == false)
                  {
                    GoodLinksDepth[GoodLinks.length] = GoodLinksDepth[LinkId]+1;
                    GoodLinks[GoodLinks.length] = ClearUrl;
                    NumOfPages++;
                    if (LimitNumOfPages && NumOfPages == MaxNumOfPages)
                      break;
                  }
                }
                if (Verbose)
                {
                  UpdateVerboseData();
                }
              }
            }

            // Add located hrefs to GoodLinks (aggressive)
            if (GoodLinksDepth[LinkId] < MaxDepth &&
                (!LimitNumOfPages || NumOfPages < MaxNumOfPages))
            {
              var PotentialLinks = UnbreakedResponseText.match(/["'<>\(\){}\[\] ](https?:\/|\.\.)?\/[^"'<>\(\){}\[\]\/ ]+\/[^"'<>\(\){}\[\] ]*/gi);
              if (PotentialLinks)
              {
                RawTotalLink += PotentialLinks.length;
                for (var i=0;i<PotentialLinks.length;i++)
                {
                  if (PotentialLinks[i].length > 1000)
                    continue; // this is probably junk...
                    
                  var TempHref = PotentialLinks[i].match(/[^"'<>\(\){}\[\] ].*/gi)[0];
                  if (!TempHref)
                    continue;
                    
                  var ClearUrl = TempHref;//.match(/[^#]*/gi)[0];
                  if (!ClearUrl.match(/^http/i))
                    ClearUrl = AddDomain(ClearUrl,Domain);
                  ClearUrl = FixLink(ClearUrl);
                  
                  if (!IsLinkToFile(ClearUrl) &&
                      ClearUrl.match(/(javascript|mailto|irc):/i) == null &&
                      ClearUrl.match(/["'\*\\ ]/i) == null &&
                      IsInUrlFilter(ClearUrl) &&
                      !IsOptOutFiltered(ClearUrl) &&
                      IsKnownLink(ClearUrl) == false)
                  {
                    GoodLinksDepth[GoodLinks.length] = GoodLinksDepth[LinkId]+1;
                    GoodLinks[GoodLinks.length] = ClearUrl;
                    NumOfPages++;
                    if (LimitNumOfPages && NumOfPages == MaxNumOfPages)
                      break;
                  }
                }
                if (Verbose)
                {
                  UpdateVerboseData();
                }
              }
            }
			
            // Add located hrefs to GoodLinks (aggressive approach 2)
            if (GoodLinksDepth[LinkId] < MaxDepth &&
                (!LimitNumOfPages || NumOfPages < MaxNumOfPages))
            {
              var PotentialLinks = UnbreakedResponseText.match(/[^"'<>\(\){}\[\] ]*\.\b(php|html|htm|asp|aspx)\b[^"'<>\(\){}\[\] ]*(?=["'>\)}\] ])/gi);
              if (PotentialLinks)
              {
                RawTotalLink += PotentialLinks.length;
                for (var i=0;i<PotentialLinks.length;i++)
                {
                  if (PotentialLinks[i].length > 1000)
                    continue; // this is probably junk...
                    
                  var TempHref = PotentialLinks[i];
                  if (!TempHref)
                    continue;
					
                  TempHref = TempHref.replace(/^\w+=/i,"");
					
                  if (TempHref.match(/^(;|\+|\-|=|!|\.)/i) != null)
                    continue;
                    
                  var ClearUrl = TempHref;//.match(/[^#]*/gi)[0];
                  if (!ClearUrl.match(/^http/i))
                    ClearUrl = AddDomain(ClearUrl,Domain);
                  ClearUrl = FixLink(ClearUrl);
                  
                  if (!IsLinkToFile(ClearUrl) &&
                      ClearUrl.match(/(javascript|mailto|irc):/i) == null &&
                      ClearUrl.match(/["'\*\\ ]/i) == null &&
                      IsInUrlFilter(ClearUrl) &&
                      !IsOptOutFiltered(ClearUrl) &&
                      IsKnownLink(ClearUrl) == false)
                  {
                    GoodLinksDepth[GoodLinks.length] = GoodLinksDepth[LinkId]+1;
                    GoodLinks[GoodLinks.length] = ClearUrl;
                    NumOfPages++;
                    if (LimitNumOfPages && NumOfPages == MaxNumOfPages)
                      break;
                  }
                }
                if (Verbose)
                {
                  UpdateVerboseData();
                }
              }
            }
            
            if (GoodLinksDepth[LinkId] <= MaxDepth  && (FileFilterType != 2 || UnbreakedResponseText.match(FileFilterRegExp) || UnbreakedResponseText.replace(/_/g," ").match(FileFilterRegExp)))
            {
              var Links = UnbreakedResponseText.match(SearchRegExp);
              if (Links && LinkedFiles)
              {
                var LinkHrefs = new Array();
                var LinkImages = new Array();
                var LinkTexts = new Array();
                var LinkFlags = new Array();
                
                GetLinksInfo(Links,true,Domain,LinkHrefs,LinkImages,LinkTexts,LinkFlags);
        
                var AnchorId=0;
                for  (var j=0;j < Links.length;j++)
                {
                  if (LinkHrefs[j] == undefined)
                    continue;
                    
                  if (LinkFlags[LinkHrefs[j]] != true)
                    continue;
    
                  if (LinkImages[LinkHrefs[j]] == undefined && IgnoreNoImage)
                    continue;
                    
                  if (FileFilterType == 1 &&
                      LinkHrefs[j].match(FileFilterRegExp) == null &&
                      LinkHrefs[j].replace(/_/g," ").match(FileFilterRegExp) == null &&
                      LinkTexts[LinkHrefs[j]].match(FileFilterRegExp) == null &&
                      LinkTexts[LinkHrefs[j]].replace(/_/g," ").match(FileFilterRegExp) == null)
                    continue;
                    
                  LinkAnchor.href = LinkHrefs[j];
                  
                  if (LinkHrefs[j].match(BackgroundRegExp))
                    LinkAnchor.target = "hidden"+AnchorId%10;
                  else
                    LinkAnchor.target = "_blank";
                  AnchorId++;
                  
                  if (LinkImages[LinkHrefs[j]] != undefined && UseGeneric == false)
                  {
                    LinkImage.src=LinkImages[LinkHrefs[j]];
                  }
                  else
                  {
                    var Extension = LinkHrefs[j].slice(LinkHrefs[j].lastIndexOf(".")).toLowerCase();
                    LinkImage.src="moz-icon://" + Extension;
                  }
                  
                  LinkImage.title=LinkTexts[LinkHrefs[j]];
                  LinkImage.alt=LinkTexts[LinkHrefs[j]];
                  
                  if (ShowDesc)
                  {
                    LinkDesc.textContent = LinkTexts[LinkHrefs[j]];
                  }
    
                  if (ShowUrls)
                  {
                    LinkOrigUrl.href = req.channel.URI.spec;
                    LinkOrigUrl.textContent = req.channel.URI.spec;
                  }
                  
                  var TempNode = LinkTemplate.cloneNode(true);
                  TempNode.id = "FileLink";
                  
                  if (IgnoreBroken)
                  {
                    ValidateLink(LinkHrefs[j]);
                  }
                  
                  Gallery.appendChild(TempNode);
                  
                  Files[Files.length] = LinkHrefs[j];
                    
                  LinkFlags[LinkHrefs[j]] = false;
                }
                LinkHrefs = null;
                LinkImages = null;
                LinkTexts = null;
                LinkFlags = null;
              }
              
              if (AnalyzeMime)
              {
                var Links = UnbreakedResponseText.match(/<a[^>]*href.*?>.*?(?=<\/?a)/gi);
                if (Links && LinkedFiles)
                {
                  //alert(Links.length);
                  var LinkHrefs = new Array();
                  var LinkImages = new Array();
                  var LinkTexts = new Array();
                  var LinkFlags = new Array();
                  
                  GetLinksInfo(Links,false,Domain,LinkHrefs,LinkImages,LinkTexts,LinkFlags);
          
                  var AnchorId=0;
                  for  (var j=0;j < Links.length;j++)
                  {
                    //alert(j + " " + LinkHrefs[j]);
                    if (LinkHrefs[j] == undefined)
                      continue;
                      
                    if (LinkFlags[LinkHrefs[j]] != true)
                      continue;
      
                    if (LinkImages[LinkHrefs[j]] == undefined && IgnoreNoImage)
                      continue;
                      
                    if (FileFilterType == 1 &&
                        LinkHrefs[j].match(FileFilterRegExp) == null &&
                        LinkTexts[LinkHrefs[j]].match(FileFilterRegExp) == null)
                      continue;
                      
                    LinkAnchor.href = LinkHrefs[j];
                    
                    if (LinkHrefs[j].match(BackgroundRegExp))
                      LinkAnchor.target = "hidden"+AnchorId%10;
                    else
                      LinkAnchor.target = "_blank";
                    AnchorId++;
                    
                    if (LinkImages[LinkHrefs[j]] != undefined && UseGeneric == false)
                    {
                      LinkImage.src=LinkImages[LinkHrefs[j]];
                    }
                    else
                    {
                      LinkImage.src="moz-icon://.exe";
                    }
                    
                    LinkImage.title=LinkTexts[LinkHrefs[j]];
                    LinkImage.alt=LinkTexts[LinkHrefs[j]];
                    
                    if (ShowDesc)
                    {
                      LinkDesc.textContent = LinkTexts[LinkHrefs[j]];
                    }
      
                    if (ShowUrls)
                    {
                      LinkOrigUrl.href = req.channel.URI.spec;
                      LinkOrigUrl.textContent = req.channel.URI.spec;
                    }
                    
                    var TempNode = LinkTemplate.cloneNode(true);
                    TempNode.id = "LuckyMime";
                    
                    if (IgnoreBroken)
                    {
                      ValidateLink(LinkHrefs[j]);
                    }
                    
                    //alert(j + " " + LinkHrefs[j] + " added");
                    Gallery.appendChild(TempNode);
                    
                    Files[Files.length] = LinkHrefs[j];
                      
                    LinkFlags[LinkHrefs[j]] = false;
                    
                    if (IsKnownLink(LinkHrefs[j]) == false)
                    {
                      GoodLinksDepth[GoodLinks.length] = GoodLinksDepth[LinkId]+1;
                      GoodLinks[GoodLinks.length] = LinkHrefs[j];
                      
                      MimeCheckList[MimeCheckList.length] = LinkHrefs[j];
                    }
                  }
                  LinkHrefs = null;
                  LinkImages = null;
                  LinkTexts = null;
                  LinkFlags = null;
                }
              }
              
              if (BigJpg)
              {
                var taggedImages = UnbreakedResponseText.match(/<img[^>]*(jpe?g|png|bmp|gif)[^>]*>/gi);
                //var taggedImages = UnbreakedResponseText.match(/<img[^>]*>/gi);
  
                var allImages = UnbreakedResponseText.match(/["'<>\(\){}\=\?~& ][^"'<>\(\){}\=\?~& ]*\.(jpe?g|png|bmp|gif)(?=["'<>\(\){}\=\?~& ])/gi);
                var images;
                
                if (taggedImages == null)
                  images = allImages;
                else if (allImages != null && allImages.length != taggedImages.length)
                  images = taggedImages.concat(allImages);
                else
                  images = taggedImages;
  
                if (images)
                {
                  for  (var j=0;j < images.length;j++)
                  {
                    var imageSrc = GetQuotedAttribute(images[j],"src",false);
                    if (!imageSrc)
                      imageSrc = images[j].match(/[^"'<>\(\){}\=\?~& ].*/gi)[0];
                    if (!imageSrc)
                      continue;
                      
                    if (!imageSrc.match(/^http/i))
                      imageSrc = AddDomain(imageSrc,Domain);
                    imageSrc = FixLink(imageSrc);
                      
                    if (IsKnownFile(imageSrc))
                      continue;
                      
                    LinkAnchor.href = imageSrc;
                    if (BJtarget == 2)
                      LinkAnchor.target = "hidden"+AnchorId%10;
                    else
                      LinkAnchor.target = "_blank";
                    AnchorId++;
                    LinkImage.src = imageSrc;
                    
                    var Desc = ""
                    var Alt = GetQuotedAttribute(images[j],"alt",true);
                    if (Alt)
                    {
                      Desc = ConcatDescription(Desc,Alt);
                    }
                    var Title = GetQuotedAttribute(images[j],"title",true);
                    if (Title)
                    {
                      Desc = ConcatDescription(Desc,Title);
                    }
                    
                    if (Desc == "")
                    {
                      var FileNameMatch = LinkImage.src.match(/([^\/]*)(?=\.[^\/]*$)/g);
                      if (FileNameMatch != null)
                        Desc = FileNameMatch[0];
                      else
                        Desc = "No Description";
                    }

                    if (FileFilterType == 1 &&
                        imageSrc.match(FileFilterRegExp) == null &&
                        imageSrc.replace(/_/g," ").match(FileFilterRegExp) == null &&
                        Desc.match(FileFilterRegExp) == null &&
                        Desc.replace(/_/g," ").match(FileFilterRegExp) == null)
                      continue;
                    
                    LinkImage.title = Desc;
                    LinkImage.alt = Desc;
                    
                    if (ShowDesc)
                    {
                      LinkDesc.textContent = Desc;
                    }
    
                    if (ShowUrls)
                    {
                      LinkOrigUrl.href = req.channel.URI.spec;
                      LinkOrigUrl.textContent = req.channel.URI.spec;
                    }
                    
                    var TempNode = LinkTemplate.cloneNode(true);
                    TempNode.id = "BigImage";
                    
                    Gallery.appendChild(TempNode);
                    
                    Files[Files.length] = imageSrc;
                  }
                }
              }
            }
          }
          
          ArrangeImages();
    
          if (Verbose)
          {
            LinksAnalyzed++;
            UpdateVerboseData();
          }
          CheckNextLinkForFiles();
  
          if (FinishedLinks >= GoodLinks.length ||
              (LimitNumOfImages && NumOfImages >= MaxNumOfImages))
          {
            StartPostProcessing();
          }
        }
      }
      catch(err)
      {
        TraceOut("FoxySpider callback error (" + err + ") catched for link: " + Link + " state = " + req.readyState);
      }
    };
    req.send(null);
  }
  catch(err)
  {
    TraceOut("FoxySpider error (" + err + ") catched for link: " + Link);
  }
}

function GetDomain(req)
{
  var BaseElem = req.responseText.match(/<base.*?>/i);
  if (BaseElem)
  {
    var Href = GetQuotedAttribute(BaseElem[0],"href",false);
    if (Href && Href.match(/["'\*\\\+\?\$, ]/i) == null)
    {
      if (Href[Href.length-1] != '/')
        Href = Href + '/';
      return Href;
    }
  }
    
  return req.channel.URI.spec.match(/https?:\/\/[^\?]*\//i)[0];
}

function GetBaseDomain(href)
{
  var Temp = href.match(/https?:\/\/[^\/]*/i);
  if (Temp)
    return Temp[0];
  else
    return "";
}

function GetLinksInfo(Links,ValidateFile,Domain,LinkHrefs,LinkImages,LinkTexts,LinkFlags)
{
  for  (var j=0;j < Links.length;j++)
  {
    Links[j] = Links[j] + "</a>";
    
    var Href = GetQuotedAttribute(Links[j],"href",false);
    if (!Href)
      continue;

    if (ValidateFile && !IsValidFileName(Href))
      continue;

    if (ValidateFile && !Href.match(ValidateRegExp))
      continue;

    LinkHrefs[j] = Href;
    if (!LinkHrefs[j].match(/^http/i))
      LinkHrefs[j] = AddDomain(LinkHrefs[j],Domain);
    LinkHrefs[j] = FixLink(LinkHrefs[j]);
      
    if (IsKnownFile(LinkHrefs[j]))
    {
      LinkFlags[LinkHrefs[j]] = false;
      continue;
    }

    if (LinkImages[LinkHrefs[j]] == undefined)
    {
      var ImgElem = Links[j].match(/<img.*?>/i);
      if (ImgElem)
      {
        var Src = GetQuotedAttribute(ImgElem[0],"src",false);
        if (Src)
        {
          LinkImages[LinkHrefs[j]] = Src;
          if (!LinkImages[LinkHrefs[j]].match(/^http/i))
            LinkImages[LinkHrefs[j]] = AddDomain(LinkImages[LinkHrefs[j]],Domain);
          LinkImages[LinkHrefs[j]] = FixLink(LinkImages[LinkHrefs[j]]);
        }
      }
    }
    
    if (LinkTexts[LinkHrefs[j]] == undefined)
     LinkTexts[LinkHrefs[j]] = "";

    var Alt = GetQuotedAttribute(Links[j],"alt",true);
    if (Alt)
    {
      LinkTexts[LinkHrefs[j]] = ConcatDescription(LinkTexts[LinkHrefs[j]],Alt);
    }
    
    var Title = GetQuotedAttribute(Links[j],"title",true);
    if (Title)
    {
      LinkTexts[LinkHrefs[j]] = ConcatDescription(LinkTexts[LinkHrefs[j]],Title);
    }
      
    var Text = Links[j].match(/>.*?</gi);
    if (Text)
    {
      LinkTexts[LinkHrefs[j]] = ConcatDescription(LinkTexts[LinkHrefs[j]],Text.join(" ").replace(/[<>]/g,""));
    }
    
    LinkFlags[LinkHrefs[j]] = true;
    if (LinkTexts[LinkHrefs[j]] == "")
    {
      var FileNameMatch = LinkHrefs[j].match(/([^\/]*)(?=\.[^\/]*$)/g);
      if (FileNameMatch != null)
        LinkTexts[LinkHrefs[j]] = FileNameMatch[0];
      else
        LinkTexts[LinkHrefs[j]] = LinkHrefs[j];
    }
  }
  
  // If the file extension is image and there is no thumbnail available, use the image itself
  for  (var j=0;j < Links.length;j++)
  {
    if (LinkHrefs[j] != undefined && LinkImages[LinkHrefs[j]] == undefined)
    {
      var Extension = LinkHrefs[j].slice(LinkHrefs[j].lastIndexOf(".")).toLowerCase();
      if (Extension == ".jpg" || Extension == ".gif" || Extension == ".bmp" || Extension == ".png")
        LinkImages[LinkHrefs[j]] = LinkHrefs[j];
    }
  }
}

function GetQuotedAttribute(Str,Attribute,Unescape)
{
  var MatchRegExp;
  var ReplaceRegExp1 = new RegExp(Attribute + "\\s*=\\s*","gi");  // removes attribute=
  var ReplaceRegExp2 = /^[\x22\x27\s]*|[\x22\x27\s]*$/g;    // removes head/tail spaces and quotations
  var Matches;
  var RetVal;
  
  if (Unescape)
    Str = unescape(Str);
  
  MatchRegExp = new RegExp(Attribute + '\\s*=\\s*".*?"',"gi");
  Matches = Str.match(MatchRegExp);
  if (Matches)
  {
    var RetVal = Matches[0];
    RetVal = RetVal.replace(ReplaceRegExp1,"");
    RetVal = RetVal.replace(ReplaceRegExp2,"");
    return RetVal;
  }
  
  MatchRegExp = new RegExp(Attribute + "\\s*=\\s*'.*?'","gi");
  Matches = Str.match(MatchRegExp);
  if (Matches)
  {
    var RetVal = Matches[0];
    RetVal = RetVal.replace(ReplaceRegExp1,"");
    RetVal = RetVal.replace(ReplaceRegExp2,"");
    return RetVal;
  }

  MatchRegExp = new RegExp(Attribute + "\\s*=[^>]*?(?=(>|\\s\\w+\\s*=))","gi");
  Matches = Str.match(MatchRegExp);
  if (Matches)
  {
    var RetVal = Matches[0];
    RetVal = RetVal.replace(ReplaceRegExp1,"");
    RetVal = RetVal.replace(ReplaceRegExp2,"");
    return RetVal;
  }
  
  return undefined;
}

function IsLinkToFile(Href)
{
  if(!IsValidFileName(Href))
    return false;
  
  if (Href.match(/\.(mpg|mpeg|mov|avi|wmv|asf|flv|rm|jpe?g|gif|png|bmp|tif|ico|pdf|doc|xls|ppt|wav|mp3|mp4|m4a|m4v|mid|midi|wma|ra|ram|exe|txt|dtd|zip|rar|tag|gz|bz2|js|swf|cab|css|pl|dll)(\?.*)?$/i) == null)
    return false;
    
  return true;
}

function IsValidFileName(Href)
{
  var FileName = Href.match(/[^\/]*$/g)[0];
  if (!FileName)
    return false;
  
  return (FileName.match(/[:]/gi) == null);
}

function IsInUrlFilter(Href)
{
  return (Href.match(UrlFilter) != null)
}

function IsOptOutFiltered(Href)
{
  for (var i=0;i<OptOutFilters.length;i++)
  {
    if (Href.match(OptOutFilters[i]) != null)
    {
      return true;
    }
  }
  
  return false;
}

function AddDomain(Link,Domain)
{
  var FullLinkName;
  if (Link.length == 0)
    FullLinkName = Domain;
  else if (Link[0] != "/")
    FullLinkName = Domain + Link;
  else
  {
    var Host = Domain.match(/https?:\/\/[^\/]*/i)[0];

    FullLinkName = Host + Link;
  }
    
  return FullLinkName;
}

function FixLink(Link)
{
  while (Link.match(/\/[^\/\.]*\/\.\.\//i))
  {
    Link = Link.replace(/\/[^\/\.]*\/\.\.\//i,"/");
  }
  
  while (Link.match(/\/\.\//i))
  {
    Link = Link.replace(/\/\.\//i,"/");
  }
  
  Link = Link.replace(/\/\//ig,"/");
  Link = Link.replace(/:\//ig,"://");
  
  return Link;
}

function ConcatDescription(Desc,NewDesc)
{
  if (NewDesc == undefined || IsEmptyString(NewDesc))
    return Desc;
    
  // Replace HTML special characters
  NewDesc = NewDesc.replace(/&.*?;/g,"");
  
  // Merge multiple white-spcaes
  NewDesc = NewDesc.replace(/\s+/g," ");
  
  // Remove head/tail white spaces
  NewDesc = NewDesc.replace(/^\s*|\s*$/g,"");

  if (NewDesc==Desc || NewDesc.match(Desc) != null)  // The new description contains the current description
    Desc = NewDesc;
  else if (Desc == undefined || IsEmptyString(Desc))  // The current description is empty
    Desc = NewDesc;
  else if (Desc.match(NewDesc) == null)  // The new description is not already included
      Desc = Desc + "|" + NewDesc;
      
  return Desc;
}

function IsEmptyString(Str)
{
  return (Str.match(/\S/) == null);
}

function HandleLinkTimeout(LinkId,req)
{
  if (Timers == null)
    return;
    
  try
  {
    TraceOut("FoxySpider timeout: " + GoodLinks[LinkId] + " " + req.readyState + "/" + req.status);
  }
  catch(err)
  {
    TraceOut("FoxySpider timeout: " + GoodLinks[LinkId]);
  }

  Timers[LinkId] = 0;
  req.abort();
  
  Tockens++;
  if (Verbose)
  {
    LinksTimedout++;
    UpdateVerboseData();
  }
  
  FinishedLinks++;
  
  if (AnalyzeMime && LuckyMime[GoodLinks[LinkId]] == undefined)
    LuckyMime[GoodLinks[LinkId]] = "text/html";
          
  CheckNextLinkForFiles();

  if (FinishedLinks >= GoodLinks.length ||
      (LimitNumOfImages && NumOfImages >= MaxNumOfImages))
  {
    StartPostProcessing();
  }
}

function ValidateLink(Link)
{
  ValidLinks[Link] = 0;
  
  var req = new XMLHttpRequest();
  
  ValidLinkTimers[Link] = setTimeout(function () {HandleValidateLinkTimeout(Link,req);},Timeout);
  
  try
  {
    req.open("GET",Link,true);
    req.onreadystatechange = function ()
    {
    
      if (ValidLinkTimers == null)        // another connection has already closed everything
        return;

      if (ValidLinkTimers[Link] == 0)      // this is an old request
        return;
        
      try
      {
        if (req.readyState > 1 && req.status == 200)
        {
          ValidLinks[Link] = 200;
          //TraceOut("FoxySpider non-broken link: " + Link + " " + req.readyState + "/" + req.status);
          if (ValidLinkTimers[Link] != 0)
          {
            clearTimeout(ValidLinkTimers[Link]);
            ValidLinkTimers[Link] = 0;
          }
          req.abort();
        }
        if ((req.readyState > 1 && req.status >= 400) || (req.readyState == 4 && req.status != 200))
        {
          TraceOut("FoxySpider broken link: " + Link + " " + req.readyState + "/" + req.status);

          ValidLinks[Link] = 400;
          if (ValidLinkTimers[Link] != 0)
          {
            clearTimeout(ValidLinkTimers[Link]);
            ValidLinkTimers[Link] = 0;
          }
          req.abort();
        }
      }
      catch(err)
      {
        //TraceOut("FoxySpider validate callback error (" + err + ") catched for link: " + Link + " state = " + req.readyState);
      }
    };
    req.send(null);
  }
  catch(err)
  {
    TraceOut("FoxySpider validate error (" + err + ") catched for link: " + Link);
  }
}

function HandleValidateLinkTimeout(Link,req)
{
  if (ValidLinkTimers == null)
    return;
    
  try
  {
    TraceOut("FoxySpider validate timeout: " + Link + " " + req.readyState + "/" + req.status);
  }
  catch(err)
  {
    TraceOut("FoxySpider validate timeout: " + Link);
  }

  ValidLinkTimers[Link] = 0;
  ValidLinks[Link] = 400;
  req.abort();
}

function SaveGallery()
{
  var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
               .createInstance(Components.interfaces.nsIFileOutputStream);
  var fp = Components.classes["@mozilla.org/filepicker;1"]
               .createInstance(Components.interfaces.nsIFilePicker);
  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");

  var GalleryHtml = document.getElementById("FoxySpiderGallery").innerHTML;
  
  GalleryHtml = '<html><head><title>FoxySpider Gallery</title><meta http-equiv="Content-Type" content="text/html;charset=utf-8"></head><body style="margin: 0px;background-color:' + bgColor + ';" onload="ExportArrangeImages();" onresize="ExportArrangeImages();">' + GalleryHtml + '</body></html>';
    
  fp.init(window,"Save FoxySpider Gallery As",fp.modeSave);
  fp.defaultExtension = "html";
  fp.defaultString = "gallery.html";
  fp.appendFilters(fp.filterHTML);
  if (prefs.prefHasUserValue("exportpath"))
  {
    var localPath = Components.classes["@mozilla.org/file/local;1"]
                    .createInstance(Components.interfaces.nsILocalFile);
    try
    {
      localPath.initWithPath(makePathCompatible(prefs.getCharPref("exportpath")));
      fp.displayDirectory = localPath;
    }
    catch(err)
    {
    }
  }
  if (fp.show() != fp.returnCancel)
  {
    prefs.setCharPref("exportpath",fp.fileURL.path);
    stream.init(fp.file,0x20|0x02|0x08,-1,0);

    var converter = Components.classes["@mozilla.org/intl/converter-output-stream;1"].
              createInstance(Components.interfaces.nsIConverterOutputStream);

    converter.init(stream,"UTF-8",0,0);
    converter.writeString(GalleryHtml);
    converter.close();
  }
}

function StartPostProcessing()
{
  if (PostProcessingStarted)
    return;
  PostProcessingStarted = true;
  DoPostProcessing();
}
  
function DoPostProcessing()
{
  StatusNode.textContent = L10n.GetStringFromName("FoxySpiderGallery.Status.finalizing");
  
  if (Verbose)
  {
    UpdateVerboseData();
  }
  
  var Imgs = Gallery.getElementsByTagName("IMG");

  if (Imgs.length == 0)
  {
    StatusNode.textContent = DoneStr;
    StopButton.disabled = "disabled";
    ExportButton.removeAttribute("disabled");
    SelectButton.removeAttribute("disabled");
    ResetButton();
    return;
  }
  
  if (StopButton.value == "stop")
  {
    var Divs = Gallery.getElementsByTagName("DIV");
    // remove all not-loaded images
    for (var i=Divs.length-1;i>-1;i--)
    {
      if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
        continue;
        
      if (Divs[i].style.visibility == "hidden")
        Gallery.removeChild(Divs[i]);
    }
  }
  
  var Imgs = Gallery.getElementsByTagName("IMG");
  
  // First wait till all images are loaded
  for (var i=0;i<Imgs.length;i++)
  {
    if (Imgs[i].complete == false && Imgs[i].naturalWidth == 0 && Imgs[i].naturalHeight == 0)
    {
      ArrangeImages();
      setTimeout(function () {DoPostProcessing();},1000);
      return;
    }
    if (IgnoreBroken && ValidLinks[Imgs[i].parentNode.href] == 0)
    {
      ArrangeImages();
      setTimeout(function () {DoPostProcessing();},1000);
      return;
    }
  }
  
  FirstRowWithInvisible = 0;
  ArrangeImages();
  
  StatusNode.textContent = DoneStr;
  StopButton.disabled = "disabled";
  if (Verbose)
  {
    UpdateVerboseData();
  }
  ExportButton.removeAttribute("disabled");
  SelectButton.removeAttribute("disabled");
  ResetButton();
  ReleaseMemory();
  AddTooltipButtons();
}

function ReleaseMemory()
{
  GoodLinks = null;
  GoodLinksDepth = null;
  Files = null;
  Timers = null;
  ValidLinks = null;
  ValidLinkTimers = null;
  OptOutFilters = null;
  Bars = null;
}

function UnresizeImages()
{
  function TemplateDiv(img)
  {
    return img.parentNode.parentNode.parentNode;
  }
  
  if (Gallery == 0)
    return;
  
  var Imgs = Gallery.getElementsByTagName("IMG");

  for (var i=Imgs.length-1;i>-1;i--)
  {
    TemplateDiv(Imgs[i]).style.marginRight = TemplateDiv(Imgs[i]).style.marginTop;
    TemplateDiv(Imgs[i]).style.marginLeft = TemplateDiv(Imgs[i]).style.marginTop;
  }
  
  FirstRowWithInvisible = 0;
}

function ArrangeImages()
{
  function TemplateDiv(img)
  {
    return img.parentNode.parentNode.parentNode;
  }
  
  if (Gallery == 0)
    return;
  
  var Imgs = Gallery.getElementsByTagName("IMG");

  for (var i=Imgs.length-1;i>-1;i--)
  {   
    if (LimitNumOfImages && NumOfImages >= MaxNumOfImages)
    {
      StopButton.value = "stop";
      StopButton.disabled = "disabled";
      
      var Divs = Gallery.getElementsByTagName("DIV");
      // remove all not-loaded images
      for (var i=Divs.length-1;i>-1;i--)
      {
        if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
          continue;
          
        if (Divs[i].style.visibility == "hidden")
          Gallery.removeChild(Divs[i]);
      }
      break;
    }
    
    if (TemplateDiv(Imgs[i]).id != "FileLink" && TemplateDiv(Imgs[i]).id != "BigImage" && TemplateDiv(Imgs[i]).id != "LuckyMime")
      continue;
    
    if (Imgs[i].complete == false && Imgs[i].naturalWidth == 0 && Imgs[i].naturalHeight == 0)
      continue;
      
    if (Imgs[i].style.visibility == "visible")
      continue;

    var href = unescape(Imgs[i].parentNode.href);
    
    if (IgnoreBroken && ValidLinks[href] == 0)
      continue;

    if (IgnoreBroken &&
        TemplateDiv(Imgs[i]).id == "FileLink" &&
        ValidLinks[href] == 400)
    {
      Gallery.removeChild(TemplateDiv(Imgs[i]));
      continue;
    }

    if (TemplateDiv(Imgs[i]).id == "BigImage" && 
        (Imgs[i].naturalWidth < BJwidth || Imgs[i].naturalHeight < BJheight))
    {
      RemoveFile(href);
      Gallery.removeChild(TemplateDiv(Imgs[i]));
      continue;
    }
    
    if (TemplateDiv(Imgs[i]).id == "LuckyMime")
    {
      if (LuckyMime[href] == undefined)
      {
        continue;
      }
      else if (LuckyMime[href].match(/^text\/html/i) ||
               !(MimeMatch(LuckyMime[href])))
      {
        RemoveFile(href);
        Gallery.removeChild(TemplateDiv(Imgs[i]));
        continue;
      }
      Imgs[i].parentNode.href = MimeFinalNameList[href];
      Imgs[i].src = "moz-icon://" + MimeFinalNameList[href].match(/\.[^\.]*$/);
    }
    
    // Fix images to the right size if resizing was ont requested
    if (ResizeMode == "noresize")
    {
      Imgs[i].style.width = Math.min(Imgs[i].naturalWidth,MaxImageWidth);
      Imgs[i].style.height = Imgs[i].naturalHeight;
    }
    if (ResizeMode == "resize")
    {
      Imgs[i].style.width = Math.min(ResizeWidth,MaxImageWidth);
      Imgs[i].style.height = ResizeHeight;
    }
    if (ResizeMode == "resizewidth")
    {
      Imgs[i].style.width = Math.min(ResizeWidth,MaxImageWidth);
      Imgs[i].style.height = Math.round(Imgs[i].naturalHeight*(ResizeWidth/Imgs[i].naturalWidth));
    }
    if (ResizeMode == "resizeheight")
    {
      Imgs[i].style.height = ResizeHeight;
      Imgs[i].style.width = Math.round(Math.min(Imgs[i].naturalWidth*(ResizeHeight/Imgs[i].naturalHeight),MaxImageWidth));
    }
    
    Imgs[i].nextSibling.style.width = parseInt(Imgs[i].style.width)-10;
    Imgs[i].parentNode.nextSibling.style.width = parseInt(Imgs[i].style.width)-10;

    if (TemplateDiv(Imgs[i]).id == "BigImage" && UseGeneric)
    {
      var OldSrc = Imgs[i].src;
      var Extension = OldSrc.slice(OldSrc.lastIndexOf(".")).toLowerCase();
      TemplateDiv(Imgs[i]).id = "BigImageGeneric";
      Imgs[i].src = "moz-icon://" + Extension;
    }
    
    TemplateDiv(Imgs[i]).style.visibility = "visible";
    TemplateDiv(Imgs[i]).style.display = "block";
    
    Imgs[i].style.visibility = "visible";

    NumOfImages++;
    
    if (Verbose)
    {
      UpdateVerboseData();
    }
  }
  
  Imgs = Gallery.getElementsByTagName("IMG");
  
  // Fix desc height
  var MaxDescHeight = 0;
  for (var i=0;i<Imgs.length;i++)
  {
    if (Imgs[i].style.visibility != "visible")
      continue;
    if (Imgs[i].nextSibling.clientHeight > MaxDescHeight)
      MaxDescHeight = Imgs[i].nextSibling.clientHeight;
  }
  
  for (var i=0;i<Imgs.length;i++)
  {
    if (Imgs[i].style.visibility != "visible")
      continue;
    Imgs[i].nextSibling.style.height = MaxDescHeight;
  }
  
  for (var i=0;i<Imgs.length;i++)
  {
    if (!Imgs[i].hasAttribute("row") || parseInt(Imgs[i].getAttribute("row")) >= FirstRowWithInvisible)
    {
      TemplateDiv(Imgs[i]).style.marginRight = TemplateDiv(Imgs[i]).style.marginTop;
      TemplateDiv(Imgs[i]).style.marginLeft = TemplateDiv(Imgs[i]).style.marginTop;
    }
  }
        
  // Fix images vertical positioning
  var FirstImageInRow = 0;
  var FirstImageInNextRow = 0;
  var RowNum = 0;
  var LastRowNum = 0;
  var FirstInvisibleFlag = true;
  while (FirstImageInRow < Imgs.length)
  {
    var MaxHeight = 0;
    while (FirstImageInNextRow < Imgs.length &&
           (TemplateDiv(Imgs[FirstImageInRow]).offsetTop == TemplateDiv(Imgs[FirstImageInNextRow]).offsetTop ||
           Imgs[FirstImageInNextRow].style.visibility != "visible"))
    {
      if (Imgs[FirstImageInNextRow].clientHeight > MaxHeight && Imgs[FirstImageInRow].style.visibility == "visible")
        MaxHeight = Imgs[FirstImageInNextRow].clientHeight;
      FirstImageInNextRow++;
    }

    for (var i=FirstImageInRow;i<FirstImageInNextRow;i++)
    {
      if (Imgs[i].style.visibility == "visible")
      {
        Imgs[i].style.marginTop = Math.ceil((MaxHeight-Imgs[i].clientHeight+2)/2);
        Imgs[i].style.marginBottom = Math.floor((MaxHeight-Imgs[i].clientHeight+2)/2);
      }
      else
        if (FirstInvisibleFlag)
        {
          FirstRowWithInvisible = RowNum;
          FirstInvisibleFlag = false;
        }
      Imgs[i].setAttribute("row",RowNum);
    }
    FirstImageInRow = FirstImageInNextRow;
    LastRowNum = RowNum;
    RowNum++;
  }
  
  // Fix images horizontal positioning
  var MaxWidth = 0;
  for (var i=0;i<Imgs.length;i++)
  {
    //if (TemplateDiv(Imgs[i]).style.visibility != "visible")
    //  continue;
    if (TemplateDiv(Imgs[i]).clientWidth + TemplateDiv(Imgs[i]).offsetLeft > MaxWidth &&
        Imgs[i].style.visibility == "visible")
      MaxWidth = TemplateDiv(Imgs[i]).clientWidth + TemplateDiv(Imgs[i]).offsetLeft;
  }
  
  if (MaxWidth > MaxImageWidth + 100)
  {
    FirstRowWithInvisible = 0;
    TraceOut("FoxySpider: Something went wrong with right justification. Restart.");
  }
    
  
  var FirstImageInRow = 0;
  var FirstImageInNextRow = 0;
  while (FirstImageInRow < Imgs.length)
  {
    if (Imgs[FirstImageInRow].getAttribute("row") == LastRowNum)
      break;
      
    var MaxWidthInRow = 0;
    var VisibleImagesInRow = 0;
    while (FirstImageInNextRow < Imgs.length &&
           Imgs[FirstImageInRow].getAttribute("row") == Imgs[FirstImageInNextRow].getAttribute("row"))
    {
      if (TemplateDiv(Imgs[FirstImageInNextRow]).clientWidth + TemplateDiv(Imgs[FirstImageInNextRow]).offsetLeft > MaxWidthInRow &&
          Imgs[FirstImageInNextRow].style.visibility == "visible")
        MaxWidthInRow = TemplateDiv(Imgs[FirstImageInNextRow]).clientWidth + TemplateDiv(Imgs[FirstImageInNextRow]).offsetLeft;
        
      if (Imgs[FirstImageInNextRow].style.visibility == "visible")
        VisibleImagesInRow++;
      
      FirstImageInNextRow++;
    }
    
    if (VisibleImagesInRow == 1)
    {
      for (i=FirstImageInRow;i<FirstImageInNextRow;i++)
      {
        if (Imgs[i].style.visibility != "visible")
          continue;
          
        TemplateDiv(Imgs[i]).style.marginLeft = 
          Math.floor((MaxWidth - TemplateDiv(Imgs[i]).clientWidth - 
                      parseInt(TemplateDiv(Imgs[i]).style.borderWidth) + parseInt(TemplateDiv(Imgs[i]).style.marginTop))/2) + 1;
        break;
      }
    }
    else
    {
      var WidthToAdd = MaxWidth - MaxWidthInRow;
      var WidthRoundUpTimes = WidthToAdd % (VisibleImagesInRow-1);
      var ModifiedImages = 0;
      
      for (i=FirstImageInRow;i<FirstImageInNextRow;i++)
      {
        if (ModifiedImages == VisibleImagesInRow - 1)
          break;

        if (Imgs[i].style.visibility != "visible")
          continue;

        if (WidthRoundUpTimes > 0)
        {
          TemplateDiv(Imgs[i]).style.marginRight = parseInt(TemplateDiv(Imgs[i]).style.marginRight) +
                                      Math.ceil(WidthToAdd/(VisibleImagesInRow-1));
          WidthRoundUpTimes--;
        }
        else
        {
          TemplateDiv(Imgs[i]).style.marginRight = parseInt(TemplateDiv(Imgs[i]).style.marginRight) +
                                      Math.floor(WidthToAdd/(VisibleImagesInRow-1));
        }
        ModifiedImages++;
      }
    }
    FirstImageInRow = FirstImageInNextRow;
  }
}

function MimeMatch(mime)
{
  var i;
  
  for (var i=0;i < MimeList.length;i++)
  {
    if (mime.match(MimeList[i]))
      return true;
  }
  return false;
}

function RotateButton()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
					   .getService(Components.interfaces.nsIWindowMediator);
  var browserEnumerator = wm.getEnumerator("navigator:browser");

  while (browserEnumerator.hasMoreElements())
  {
    var win = browserEnumerator.getNext();
    var Button = win.document.getElementById("foxyspider-toolbar-button");
    
    if (Button == null)
      continue;
    
    var toolbar = Button.parentNode;

    if (toolbar.getAttribute("iconsize") == "small")
      Button.style.listStyleImage = 'url("chrome://foxyspider/skin/foxyspider_small_rotate.gif")';
    else
      Button.style.listStyleImage = 'url("chrome://foxyspider/skin/foxyspider_rotate.gif")';
  }
}

function ResetButton()
{
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
					   .getService(Components.interfaces.nsIWindowMediator);
  var browserEnumerator = wm.getEnumerator("navigator:browser");

  while (browserEnumerator.hasMoreElements())
  {
    var win = browserEnumerator.getNext();
    var Button = win.document.getElementById("foxyspider-toolbar-button");
    
    if (Button == null)
      continue;
    
    var toolbar = Button.parentNode;

    Button.style.listStyleImage = "";
  }
}

function TraceOut(str)
{
  var ConsSrv = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
    
  ConsSrv.logStringMessage(str);
}

function makePathCompatible(path)
{
  if (navigator.platform=="Win32")
  {
    path=path.replace(/\//g,"\\");
    path=path.replace(/^\\{3}/,"\\\\");
    if (path.indexOf(":")>0)
    {
      path=path.replace(/^\\/g,"");
    }
    path=path.replace(/^\\$/,"c:\\");
  }
  return path;
}

function DownloadSelected()
{
  var Anchors = document.getElementById("Gallery").getElementsByTagName("A");

  var fp = Components.classes["@mozilla.org/filepicker;1"]
               .createInstance(Components.interfaces.nsIFilePicker);
               
  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");
                  
  fp.init(window,"Select a directory",fp.modeGetFolder);
  
  if (prefs.prefHasUserValue("downloadpath"))
  {
    var localPath = Components.classes["@mozilla.org/file/local;1"]
                    .createInstance(Components.interfaces.nsILocalFile);
    try
    {
      localPath.initWithPath(makePathCompatible(prefs.getCharPref("downloadpath")));
      fp.displayDirectory = localPath;
    }
    catch(err)
    {
    }
  }

  if (fp.show() == fp.returnCancel)
    return;

  prefs.setCharPref("downloadpath",fp.fileURL.path);
    
  var fileNames = new Array();
      
  for (var i=0;i<Anchors.length;i++)
  {
    if (Anchors[i].id != "LinkAnchor")
      continue;
      
    if (Anchors[i].parentNode.parentNode.style.borderColor != "red")
      continue;
      
    // Got instance of download manager
    var dm = Components.classes["@mozilla.org/download-manager;1"].
        createInstance(Components.interfaces.nsIDownloadManager);

    // Create URI from which we want to download file
    var ios = Components.classes["@mozilla.org/network/io-service;1"].
        getService(Components.interfaces.nsIIOService);
    var uri1 = ios.newURI(Anchors[i].href,null,null);

    var file = fp.file.clone();
    var nameMatch = Anchors[i].href.match(/[^\/]*$/g);
    if (nameMatch == null)
      continue;
    var name = nameMatch[0];
    name = name.match(/[^\?#]*/g)[0];
    
    file.append(name);
    var nameCount = 0;
    var fileName = file.leafName;
    while (file.exists() || fileNames[file.leafName])
    {
      nameCount++;
      file.leafName = fileName;
      file.leafName = file.leafName.replace(/\.(?=[^\.]*$)/,"("+nameCount+").");
    }
    fileNames[file.leafName] = true;
    var uri2 = ios.newFileURI(file);

    // Set up correct MIME type
    //var msrv = Components.classes["@mozilla.org/mime;1"].
    //    getService(Components.interfaces.nsIMIMEService);
    //var type = msrv.getTypeFromURI(uri1);
    //var mime = msrv.getFromTypeAndExtension(type,"");

    // Observer for download
    var nsIWBP = Components.interfaces.nsIWebBrowserPersist;
    var pers = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
        createInstance(nsIWBP);
    pers.persistFlags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES |
        nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

    // Start download
    var dl = dm.addDownload(dm.DOWNLOAD_TYPE_DOWNLOAD,uri1,uri2,
        file.leafName,null,Math.round(Date.now() * 1000),
        null,pers,false);
    pers.progressListener = dl.QueryInterface(Components.interfaces.nsIWebProgressListener);
    pers.saveURI(dl.source,null,null,null,null,dl.targetFile,null);

    // And finally show download manager
    //var dm_ui = Components.classes["@mozilla.org/download-manager-ui;1"].
    //    createInstance(Components.interfaces.nsIDownloadManagerUI);
    //dm_ui.show(window, dl.id, Components.interfaces.nsIDownloadManagerUI.REASON_NEW_DOWNLOAD);
  }
}

var SelectCount = 0;

function SelectDiv(e)
{
  if (this.style.borderColor != "red")
  {
    SelectCount++;
    this.style.borderColor = "red";
  }
  else
  {
    SelectCount--;
    this.style.borderColor = "transparent";
  }
  if (SelectCount == 0)
  {
    document.getElementById("DownloadButton").setAttribute("disabled","disabled");
    document.getElementById("DownloadButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.DownloadButton");
  }
  else
  {
    document.getElementById("DownloadButton").removeAttribute("disabled");
    document.getElementById("DownloadButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.DownloadButton") + " (" + SelectCount + ")";
  }
  e.preventDefault();
}

function SelectAll()
{
  var Divs = document.getElementById("Gallery").getElementsByTagName("DIV");

  for (var i=0;i<Divs.length;i++)
  {
    if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
      continue;
      
    if (Divs[i].style.borderColor != "red")
    {
      SelectCount++;
      Divs[i].style.borderColor = "red";
    }
  }
  if (SelectCount > 0)
  {
    document.getElementById("DownloadButton").removeAttribute("disabled");
    document.getElementById("DownloadButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.DownloadButton") + " (" + SelectCount + ")";
  }
  document.getElementById("SelectKeywords").style.display = "none";
}

function SelectNone()
{
  var Divs = document.getElementById("Gallery").getElementsByTagName("DIV");

  for (var i=0;i<Divs.length;i++)
  {
    if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
      continue;
  
    if (Divs[i].style.borderColor == "red")
    {
      Divs[i].style.borderColor = "transparent";
    }
  }
  SelectCount=0;
  SelectStop();
  document.getElementById("DownloadButton").setAttribute("disabled","disabled");
  document.getElementById("DownloadButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.DownloadButton");
  document.getElementById("SelectKeywords").style.display = "none";
}
function SelectStart()
{
  document.getElementById("SelectKeywords").style.display = "none";
  var Divs = document.getElementById("Gallery").getElementsByTagName("DIV");

  for (var i=0;i<Divs.length;i++)
  {
    if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
      continue;
    
    Divs[i].addEventListener("click",SelectDiv,false);
    Divs[i].style.cursor="cell";
    Anchs = Divs[i].getElementsByTagName("A");
    Anchs[0].style.cursor="cell";
    Anchs[1].style.cursor="cell";
  }
}

function SelectStop()
{
  var Divs = document.getElementById("Gallery").getElementsByTagName("DIV");

  for (var i=0;i<Divs.length;i++)
  {
    if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
      continue;
  
    Divs[i].removeEventListener("click",SelectDiv,false);
    Divs[i].style.cursor="auto";
    var Anchs = Divs[i].getElementsByTagName("A");
    Anchs[0].style.cursor="pointer";
    Anchs[1].style.cursor="pointer";
  }
}

function SelectKeywords()
{
  document.getElementById("SelectKeywords").style.display = "inline-block";
  var Divs = document.getElementById("Gallery").getElementsByTagName("DIV");
  var kw = document.getElementById("SelectKeywords").value;

  kw = kw.replace(/^\s*|\s*$/g,"");    // removes head/tail spaces
  kw = kw.replace(/\s+/g," ");         // Merge multiple white-spcaes
  kw = kw.replace(/\\/g,"/");
  kw = kw.replace(/\./g,"\\.")
  kw = kw.replace(/\*/g,".*");
  kw = kw.replace(/\+/g,"\\+");
  kw = kw.replace(/\?/g,"\\?");
  kw = kw.replace(/https?:\/\//g,"https?://");
  
  kw = escape(kw);
  kw = kw.replace(/%20/g,"|");
  kw = kw.replace(/%/g,"");

  if (kw == "") 
    kw = "[^\\w\\W]";
  else
    kw = "\\b(" + kw + ")\\b";

  var kwRegExp = RegExp(kw,"gi");

  for (var i=0;i<Divs.length;i++)
  {
    if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
      continue;
      
    var LinkAnchor = Divs[i].firstChild.firstChild;
    var LinkDesc = LinkAnchor.lastChild;
    var refStr = LinkAnchor.href + " " + LinkDesc.textContent;
    
    refStr = refStr.replace(/[:#\-"'<>\(\){}\[\] ]/g," ");
    refStr = escape(refStr);
    refStr = refStr.replace(/%20/g," ");
    refStr = refStr.replace(/%/g,"");

    if (refStr.match(kwRegExp) || refStr.replace(/_/g," ").match(kwRegExp))
    {
      if (Divs[i].style.borderColor != "red")
      {
        SelectCount++;
        Divs[i].style.borderColor = "red";
      }
    }
    else
    {
      if (Divs[i].style.borderColor == "red")
      {
        SelectCount--;
        Divs[i].style.borderColor = "transparent";
      }
    }
  }
  if (SelectCount == 0)
  {
    document.getElementById("DownloadButton").setAttribute("disabled","disabled");
    document.getElementById("DownloadButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.DownloadButton");
  }
  else
  {
    document.getElementById("DownloadButton").removeAttribute("disabled");
    document.getElementById("DownloadButton").textContent = L10n.GetStringFromName("FoxySpiderGallery.DownloadButton") + " (" + SelectCount + ")";
  }
}

function StopCrawl()
{
  document.getElementById("StopButton").value='stop';
  document.getElementById("StopButton").disabled='disabled';
  document.getElementById("Status").textContent = L10n.GetStringFromName("FoxySpiderGallery.Status.finalizing");
}

function InitL10n()
{
  try
  {
    var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
    L10n = stringBundleService.createBundle("chrome://foxyspider/locale/gallery.properties");
  }
  catch (err)
  {
    TraceOut("FoxySpider: error loading gallery localization strings " + err);
  }
}

function UpdateVerboseData()
{  
  try
  {
    LinksTotalNode.textContent = TotalLinksStr + " " + GoodLinks.length.toLocaleString() + "/" + RawTotalLink.toLocaleString();
    LinksIssuedNode.textContent = IssuedLinksStr + " " + LinksIssued.toLocaleString();
    LinksAnalyzedNode.textContent = AnalyzedLinksStr + " " + LinksAnalyzed.toLocaleString();
    LinksErroredNode.textContent = ErroredLinksStr + " " + LinksErrored.toLocaleString();
    LinksTimedoutNode.textContent = TimedoutLinksStr + " " + LinksTimedout.toLocaleString();
    ImagesNumNode.textContent = NumOfImagesStr + " " + NumOfImages.toLocaleString();
    TotalBytesNode.textContent = TotalBytesStr + " " + TotalBytes.toLocaleString();
    TimeElapsedNode.textContent = ElapsedTimeStr + " " + ((Date.now() - StartTime) / 1000).toLocaleString();
  }
  catch (err)
  {
    TraceOut("FoxySpider: error on UpdateVerboseData " + err);
  }
}

function FadeInImages()
{
  var Imgs = Gallery.getElementsByTagName("IMG");

  if (StatusNode.textContent == DoneStr)
  {
    for (var i=0;i<Imgs.length;i++)
    {
      Imgs[i].style.opacity = 1;
    }
  }
  else
  {
    var TransparentFound = false;
    for (var i=FirstTransparent;i<Imgs.length;i++)
    {
      if (Imgs[i].style.visibility == "visible" && Imgs[i].style.opacity < 1)
      {
        Imgs[i].style.opacity = parseFloat(Imgs[i].style.opacity) + 0.1;
      }
      if (!TransparentFound)
      {
        if (Imgs[i].style.opacity < 1)
        {
          FirstTransparent = i;
          TransparentFound = true;
        }
      }
    }
    setTimeout(function () {FadeInImages();},100);
  }
}

function AddTooltipButtons()
{
  var Divs = Gallery.getElementsByTagName("DIV");
    
  for (var i=0;i<Divs.length;i++)
  {
    if (Divs[i].id != "FileLink" && Divs[i].id != "BigImage" && Divs[i].id != "LuckyMime")
      continue;
      
    //Divs[i].onmouseover = AddShareButton;
    Divs[i].addEventListener("mouseover",ShowTooltipButtons,false);
    Divs[i].addEventListener("mouseout",HideTooltipButtons,false);
  }
}
      
      
function ShowTooltipButtons()
{
  var tooltip;
  var imgWidth;
  var imgHeight;
  
  tooltip = this.lastChild;
  if (tooltip.id == "TooltipButtons")
  {
    tooltip.setAttribute("position","over");
    return;
  }
  
  var Imgs = this.getElementsByTagName("img");
  for (var i=0;i<Imgs.length;i++)
  {
    if (Imgs[i].id != "LinkImage")
      continue;
    
    imgWidth = parseInt(Imgs[i].style.width);
    imgHeight = parseInt(Imgs[i].style.height);
  }

  tooltip = document.getElementById("TooltipButtons").cloneNode(true);
  
  var left = 0;
  var top = 0;

  var oElement = this;
  while (oElement != null)
  {
    left += oElement.offsetLeft;
    top += oElement.offsetTop;
    oElement = oElement.offsetParent;
  }
  
  tooltip.style.visibility = "visible";
  tooltip.style.left = left+imgWidth-95;
  tooltip.style.top = top+imgHeight-15;
  tooltip.setAttribute("position","over");
  tooltip.addEventListener("mouseover",OverTooltipButtons,false);
  var buttons = tooltip.getElementsByTagName("img");
  for (var i=0;i<buttons.length;i++)
  {
    if (buttons[i].id == "TwitterButton")
      buttons[i].addEventListener("click",ClickTwitterButton,false);
    if (buttons[i].id == "FacebookButton")
      buttons[i].addEventListener("click",ClickFacebookButton,false);
    if (buttons[i].id == "DownloadFileButton")
      buttons[i].addEventListener("click",ClickDownloadButton,false);
    if (buttons[i].id == "DeleteButton")
      buttons[i].addEventListener("click",ClickDeleteButton,false);
  }
  this.appendChild(tooltip);
}

function OverTooltipButtons()
{
  this.setAttribute("position","over");
}

function ClickFacebookButton()
{
  var Div = this.parentNode.parentNode;
  
  var Anchors = Div.getElementsByTagName("A");
  for (var i=0;i<Anchors.length;i++)
  {
    if (Anchors[i].id != "LinkAnchor")
      continue;
      
    var img = Anchors[i].firstChild;
    
    window.open("https://www.facebook.com/sharer/sharer.php?s=100&p[title]=" + encodeURIComponent(img.title) + "&p[summary]=Shared+by+FoxySpider [http://www.facebook.com/FoxySpider]&p[url]=" + encodeURIComponent(Anchors[i].href) + "&p[images][0]=" + encodeURIComponent(img.src) + "&",
    "FoxySpider","scrollbars=no");
  }
}

function ClickTwitterButton()
{
  var Div = this.parentNode.parentNode;
  
  var Anchors = Div.getElementsByTagName("A");
  for (var i=0;i<Anchors.length;i++)
  {
    if (Anchors[i].id != "LinkAnchor")
      continue;
      
    var img = Anchors[i].firstChild;
    
    window.open("http://api.addthis.com/oexchange/0.8/forward/twitter/offer?pco=tbxnj-1.0&url=" + encodeURIComponent(Anchors[i].href) + "&pubid=ra-4ebfe7e22e7d8f2e&via=foxyspider&title=" + encodeURIComponent(img.title),
    "FoxySpider","scrollbars=no");
  }
}

function ClickDownloadButton()
{
  var fp = Components.classes["@mozilla.org/filepicker;1"]
               .createInstance(Components.interfaces.nsIFilePicker);
               
               
  var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService).getBranch("extensions.foxyspider.");

  var Div = this.parentNode.parentNode;
  
  var Anchors = Div.getElementsByTagName("A");
  for (var i=0;i<Anchors.length;i++)
  {
    if (Anchors[i].id != "LinkAnchor")
      continue;
  
    fp.init(window,"Download File As",fp.modeSave);
    fp.defaultString = Anchors[i].href.match(/[^\/]*$/g)[0];
    fp.appendFilters(fp.filterAll);
    if (prefs.prefHasUserValue("downloadpath"))
    {
      var localPath = Components.classes["@mozilla.org/file/local;1"]
                      .createInstance(Components.interfaces.nsILocalFile);
      try
      {
        localPath.initWithPath(makePathCompatible(prefs.getCharPref("downloadpath")));
        fp.displayDirectory = localPath;
      }
      catch(err)
      {
      }
    }

    if (fp.show() == fp.returnCancel)
      return;
      
    prefs.setCharPref("downloadpath",fp.fileURL.path);
  
    // Got instance of download manager
    var dm = Components.classes["@mozilla.org/download-manager;1"].
        createInstance(Components.interfaces.nsIDownloadManager);

    // Create URI from which we want to download file
    var ios = Components.classes["@mozilla.org/network/io-service;1"].
        getService(Components.interfaces.nsIIOService);
    var uri1 = ios.newURI(Anchors[i].href,null,null);
    var file = fp.file.clone();
    var uri2 = ios.newFileURI(file);

    // Observer for download
    var nsIWBP = Components.interfaces.nsIWebBrowserPersist;
    var pers = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
        createInstance(nsIWBP);
    pers.persistFlags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES |
        nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;

    // Start download
    var dl = dm.addDownload(dm.DOWNLOAD_TYPE_DOWNLOAD,uri1,uri2,
        file.leafName,null,Math.round(Date.now() * 1000),
        null,pers,false);
    pers.progressListener = dl.QueryInterface(Components.interfaces.nsIWebProgressListener);
    pers.saveURI(dl.source,null,null,null,null,dl.targetFile,null);
  }
}

function ClickDeleteButton()
{
  var Div = this.parentNode.parentNode;
  
  Div.parentNode.removeChild(Div);
  UnresizeImages();
  ArrangeImages();
}

function HideTooltipButtons()
{
  var div = this;
  var tooltip = this.lastChild;
  
  if (tooltip.id == "TooltipButtons")
  {
    tooltip.setAttribute("position","out");
    setTimeout(function () { var tooltip = div.lastChild; if (tooltip.id == "TooltipButtons" && tooltip.getAttribute("position") == "out") div.removeChild(tooltip);},100);
  }
}
